function [G1,impact,irf,eu,kappa] = ATIIP_extmod_fun(bigpi,beta,epsp,epsw,thetap,thetaw,alpp,alpw,phip,phiy,phidy,rho1,b,g,shocks,h)
% "A Theory of Intrinsic Inflation Persistence" 
% by Takushi Kurozumi and Willem Van Zandweghe
rho_i = shocks(1,1);
rho_a = shocks(2,1);
stdmat = [-shocks(1,2) 0; 0 shocks(2,2)];

%% STEADY-STATE CONDITIONS
gamp=thetap*(1+epsp);
s = (1-alpp)/(1-alpp*bigpi^gamp)*((1-alpp*bigpi^(gamp-1))/(1-alpp))^(gamp/(gamp-1));
eps1 = epsp*((1-alpp)/(1-alpp*bigpi^(gamp-1)))^(gamp/(gamp-1));
eps2 = eps1*(1-alpp*beta*bigpi^(gamp-1))/(1-alpp*beta*bigpi^(-1));
kappa = (1-alpp*bigpi^(gamp-1))*(1-alpp*beta*bigpi^gamp) /...
    ( alpp*bigpi^(gamp-1)*(1-eps2*gamp/(gamp-1-eps2)) );
kappadtilde = (1-alpp*bigpi^(gamp-1))*(1-alpp*beta*bigpi^(gamp-1)) /...
    ( alpp*bigpi^(gamp-1)*(1-eps2*(1+gamp)/(gamp-1)) );
kappad = gamp*(kappa-kappadtilde) - alpp*beta*bigpi^gamp - 1/(alpp*bigpi^(gamp-1));
kappalambda = (1-alpp*bigpi^(gamp-1))/(alpp*bigpi^(gamp-1)*(1-eps2*(1+gamp)/(gamp-1))) *...
    (alpp*beta*bigpi^(gamp-1)*(bigpi-1) - eps2/(gamp-1)*alpp*beta*bigpi^(-1)*(bigpi^(gamp+1)-1));
kappaed = -eps1*alpp*bigpi^(-1)*(bigpi^gamp-1) / ((1+eps1)*(1-alpp*bigpi^(-1)));
rhod = alpp*bigpi^(-1)*(1+eps1*bigpi^gamp)/(1+eps1);
kappaf = beta*(bigpi-1)*(1-alpp*bigpi^(gamp-1)) / (1-eps2*(1+gamp)/(gamp-1));
kappaef = eps2*beta*(bigpi^(1+gamp)-1)*(1-alpp*bigpi^(gamp-1)) /...
    ( bigpi^gamp*(gamp-1-eps2*(1+gamp)) );
% mc = ((gamp-1-eps2)/gamp)*(1-alpp*beta*bigpi^gamp)/(1-alpp*beta*bigpi^(gamp-1)) /...
% ( 1/(1+epsp)*((1-alpp)/(1-alpp*bigpi^(gamp-1)))^(1/(1-gamp))+epsp/(1+epsp)*(1-alpp)/(1-alpp*bigpi^(-1)) );
% psiY = 1/mc - (s+epsp)/(1+epsp);
psiY = 0;
gamw=thetaw*(1+epsw);
bigpiw = g*bigpi;
% sw = (1-alpw)/(1-alpw*bigpiw^gamw)*( (1-alpw)/(1-alpw*bigpiw^(gamw-1)) )^(gamw/(1-gamw));
eps1w = epsw*( (1-alpw)/(1-alpw*bigpiw^(gamw-1)) )^(gamw/(gamw-1));
eps2w = eps1w*(1-alpw*beta*bigpiw^(gamw-1)) / (1-alpw*beta*bigpiw^(-1));
eps3w = eps1w*(1-alpw*beta*bigpiw^(2*gamw))/(1-alpw*beta*bigpiw^gamw);
kappaw = (1+eps1w)*(1-alpw*bigpiw^(gamw-1))*(1-alpw*beta*bigpiw^(2*gamw)) /...
    ( alpw*bigpiw^(gamw-1)*((1+eps3w)*(1-eps2w*gamw/(gamw-1-eps2w))+gamw) );
kappadwtilde = (1+eps3w)*(1-alpw*bigpiw^(gamw-1))*(1-alpw*beta*bigpiw^(gamw-1)) /...
    ( alpw*bigpiw^(gamw-1)*((1+eps3w)*(1-eps2w*(1+gamw)/(gamw-1))+gamw*(1-eps2w/(gamw-1))) );
kappadw = gamw*( kappaw*(1+1/(1+eps1w))-kappadwtilde ) - alpw*beta*bigpiw^(2*gamw) - 1/(alpw*bigpiw^(gamw-1));
kappaew = eps2w*(1+eps3w)*(1-alpw*bigpiw^(gamw-1))*(1-alpw*beta*bigpiw^(-1)) /...
    ( alpw*bigpiw^(gamw-1)*((1+eps3w)*(gamw-1-eps2w*(1+gamw))+gamw*(gamw-1-eps2w)) );
kappaefEHL = -eps3w*beta*bigpiw*(bigpiw^gamw-1)*(1-alpw*bigpiw^(gamw-1)) /...
    ( (1+eps3w)*(1-eps2w*gamw/(gamw-1-eps2w))+gamw );
kappafw = beta*(bigpiw^(gamw+1)-1)*(1+eps3w)*(1-alpw*bigpiw^(gamw-1)) /...
    ( (1+eps3w)*(1-eps2w*(1+gamw)/(gamw-1))+gamw*(1-eps2w/(gamw-1)) );
kappaefw = -eps2w*beta*(bigpiw^(2*gamw+1)-1)*(1+eps3w)*(1-alpw*bigpiw^(gamw-1))/...
    ( bigpiw^gamw*((1+eps3w)*(gamw-1-eps2w*(1+gamw))+gamw*(gamw-1-eps2w)) );
rhodw = alpw*bigpiw^(-1)*(1+eps1w*bigpiw^gamw)/(1+eps1w);
kappaedw = -eps1w*alpw*bigpiw^(-1)*(bigpiw^gamw-1)/( (1+eps1w)*(1-alpw*bigpiw^(-1)) );
%% MODEL WITH CURVATURE IN PRODUCT AND LABOR DEMAND CURVES
% Variables
ipi = 1;
ipiw = 2;
ii = 3;
iDelta = 4;
id = 5;
idw = 6;
iN = 7;
imc = 8;
iw = 9;
iy = 10;
ilambda = 11;
iphi = 12;
ipsi = 13;
iphiw = 14;
ipsiw = 15;
izetaw = 16;
ie1pi = 17;
ie1piw = 18;
ie1y = 19;
ie1lambda = 20;
ie1N = 21;
ie1d = 22;
ie1w = 23;
ie1dw = 24;
ie1phi = 25;
ie1psi = 26;
ie1phiw = 27;
ie1psiw = 28;
ie1zetaw = 29;
ie1za = 30;
izm = 31;
iza = 32;
%% INITIALIZE MATRICES
nx = 32;
nd = 14; %number of expectational variables
numshock = 2; %number of shocks
Gamma0 = zeros(nx,nx);
Gamma1 = zeros(nx,nx);
%% MODEL EQUATIONS
%EQUATION 1: EULER EQUATION
Gamma0(1,ilambda) = -1;
Gamma0(1,ie1lambda) = 1;
Gamma0(1,ii) = 1;
Gamma0(1,ie1pi) = -1;
Gamma0(1,ie1za) = -1;
%EQUATION 2: MARGINAL UTILITY (EXTERNAL HABIT FORMATION)
Gamma0(2,ilambda) = 1;
Gamma0(2,iy) = g/(g-b);
Gamma0(2,iza) = b/(g-b);
Gamma1(2,iy) = b/(g-b);
%EQUATION 3: TAYLOR RULE
Gamma0(3,ii) = 1;
Gamma0(3,ipi) = -(1-rho1)*phip;
Gamma0(3,iy) = -(1-rho1)*(phiy+phidy);
Gamma0(3,iza) = -(1-rho1)*phidy;
Gamma0(3,izm) = -1;
Gamma1(3,ii) = rho1;
Gamma1(3,iy) = -(1-rho1)*phidy;
%EQUATION 4: PRODUCTION FUNCTION
Gamma0(4,iy) = 1;
Gamma0(4,iDelta) = 1;
Gamma0(4,iN) = -(1+psiY*(1+epsp)/(s+epsp));
%EQUATION 5: LAW OF MOTION FOR RELATIVE PRICE DISTORTION
Gamma0(5,iDelta) = 1;
Gamma0(5,ipi) = -(s/(s+epsp))*gamp*alpp*bigpi^(gamp-1)*(bigpi-1)/(1-alpp*bigpi^(gamp-1));
Gamma0(5,id) = -(s/(s+epsp))*gamp*alpp*bigpi^(gamp-1)*(bigpi-1)/(1-alpp*bigpi^(gamp-1));
Gamma1(5,id) = -(s/(s+epsp))*gamp*alpp*bigpi^(gamp-1)*(bigpi-1)/(1-alpp*bigpi^(gamp-1));
Gamma1(5,iDelta) = alpp*bigpi^gamp;
%EQUATION 6: REAL MARGINAL COST
Gamma0(6,imc) = 1;
Gamma0(6,iw) = -1;
Gamma0(6,ii) = -1;
%EQUATION 7: GNKPC
Gamma0(7,ipi) = 1;
Gamma0(7,ie1pi) = -beta*bigpi;
Gamma0(7,ie1d) = -beta*bigpi;
Gamma0(7,imc) = -kappa;
Gamma0(7,id) = -kappad;
Gamma0(7,ilambda) = kappalambda;
Gamma0(7,iy) = kappalambda;
Gamma0(7,iphi) = -1;
Gamma0(7,ipsi) = -1;
Gamma1(7,id) = 1;
%EQUATION 8: AUXILIARY PRICE VARIABLE 1
Gamma0(8,iphi) = -1;
Gamma0(8,ie1phi) = alpp*beta*bigpi^(gamp-1);
Gamma0(8,ie1pi) = kappaf*(gamp-1);
Gamma0(8,ie1d) = kappaf*gamp*(1-alpp*beta*bigpi^(gamp-1));
Gamma0(8,ie1lambda) = kappaf*(1-alpp*beta*bigpi^(gamp-1));
Gamma0(8,ie1y) = kappaf*(1-alpp*beta*bigpi^(gamp-1));
%EQUATION 9: LAW OF MOTION FOR PRICE DISPERSION d
Gamma0(9,id) = 1;
Gamma0(9,ipi) = -kappaed;
Gamma1(9,id) = rhod;
%EQUATION 10: AUXILIARY PRICE VARIABLE 2
Gamma0(10,ipsi) = -1;
Gamma0(10,ie1psi) = alpp*beta*bigpi^(-1);
Gamma0(10,ie1pi) = kappaef;
Gamma0(10,ie1lambda) = -kappaef*(1-alpp*beta*bigpi^(-1));
Gamma0(10,ie1y) = -kappaef*(1-alpp*beta*bigpi^(-1));
%EQUATION 11: WAGE INFLATION
Gamma0(11,ipiw) = 1;
Gamma0(11,ipi) = -1;
Gamma0(11,iw) = -1;
Gamma0(11,iza) = -1;
Gamma1(11,iw) = -1;
%EQUATION 12: WAGE GNKPC
Gamma0(12,ipiw) = 1;
Gamma0(12,ie1piw) = -beta*bigpiw^(gamw+1);
Gamma0(12,iN) = -kappaw*2 + kappadwtilde - kappaew;
Gamma0(12,iw) = kappaw;
Gamma0(12,ilambda) = kappadwtilde - kappaew;
Gamma0(12,idw) = -kappadw;
Gamma0(12,ie1dw) = -beta*bigpiw^(gamw+1);
Gamma0(12,izetaw) = -1;
Gamma0(12,iphiw) = -1;
Gamma0(12,ipsiw) = -1;
Gamma1(12,idw) = 1;
%EQUATION 13: AUXILIARY WAGE VARIABLE 1 (phiw)
Gamma0(13,iphiw) = -1;
Gamma0(13,ie1phiw) = alpw*beta*bigpiw^(gamw-1);
Gamma0(13,ie1N) = kappafw*(1-alpw*beta*bigpiw^(gamw-1));
Gamma0(13,ie1lambda) = kappafw*(1-alpw*beta*bigpiw^(gamw-1));
Gamma0(13,ie1dw) = kappafw*(1-alpw*beta*bigpiw^(gamw-1))*gamw;
Gamma0(13,ie1piw) = kappafw*gamw;
Gamma0(13,ie1pi) = -kappafw;
Gamma0(13,ie1za) = -kappafw;
%EQUATION 14: LAW OF MOTION FOR WAGE DISPERSION dw
Gamma0(14,idw) = 1;
Gamma0(14,ipiw) = -kappaedw;
Gamma1(14,idw) = rhodw;
%EQUATION 15: AUXILIARY WAGE VARIABLE 2 (psiw)
Gamma0(15,ipsiw) = -1;
Gamma0(15,ie1psiw) = alpw*beta*bigpiw^(-1);
Gamma0(15,ie1N) = kappaefw*(1-alpw*beta*bigpiw^(-1));
Gamma0(15,ie1lambda) = kappaefw*(1-alpw*beta*bigpiw^(-1));
Gamma0(15,ie1pi) = -kappaefw;
Gamma0(15,ie1za) = -kappaefw;
%EQUATION 16: AUXILIARY WAGE VARIABLE 3 (zetaw)
Gamma0(16,izetaw) = -1;
Gamma0(16,ie1zetaw) = alpw*beta*bigpiw^gamw;
Gamma0(16,ie1N) = kappaefEHL*(1-alpw*beta*bigpiw^gamw)*2;
Gamma0(16,ie1w) = -kappaefEHL*(1-alpw*beta*bigpiw^gamw) + kappaefEHL;
Gamma0(16,ie1dw) = kappaefEHL*(1-alpw*beta*bigpiw^gamw)*gamw;
Gamma0(16,iw) = -kappaefEHL ;
Gamma0(16,ie1piw) = kappaefEHL*gamw;
%EQUATION 17: Definition of E(t)pi(t+1)
Gamma0(17,ipi) = 1;
Gamma1(17,ie1pi) = 1;
%EQUATION 18: Definition of E(t)piw(t+1)
Gamma0(18,ipiw) = 1;
Gamma1(18,ie1piw) = 1;
%EQUATION 19: Definition of E(t)Y(t+1)
Gamma0(19,iy) = 1;
Gamma1(19,ie1y) = 1;
%EQUATION 20: Definition of E(t)lambda(t+1)
Gamma0(20,ilambda) = 1;
Gamma1(20,ie1lambda) = 1;
%EQUATION 21: Definition of E(t)d(t+1)
Gamma0(21,id) = 1;
Gamma1(21,ie1d) = 1;
%EQUATION 22: Definition of E(t)N(t+1)
Gamma0(22,iN) = 1;
Gamma1(22,ie1N) = 1;
%EQUATION 23: Definition of E(t)w(t+1)
Gamma0(23,iw) = 1;
Gamma1(23,ie1w) = 1;
%EQUATION 24: Definition of E(t)dw(t+1)
Gamma0(24,idw) = 1;
Gamma1(24,ie1dw) = 1;
%EQUATION 25: Definition of E(t)phi(t+1)
Gamma0(25,iphi) = 1;
Gamma1(25,ie1phi) = 1;
%EQUATION 26: Definition of E(t)psi(t+1)
Gamma0(26,ipsi) = 1;
Gamma1(26,ie1psi) = 1;
%EQUATION 27: Definition of E(t)phiw(t+1)
Gamma0(27,iphiw) = 1;
Gamma1(27,ie1phiw) = 1;
%EQUATION 28: Definition of E(t)psiw(t+1)
Gamma0(28,ipsiw) = 1;
Gamma1(28,ie1psiw) = 1;
%EQUATION 29: Definition of E(t)zetaw(t+1)
Gamma0(29,izetaw) = 1;
Gamma1(29,ie1zetaw) = 1;
%EQUATION 30: Definition of E(t)za(t+1)
Gamma0(30,iza) = 1;
Gamma1(30,ie1za) = 1;
%EQUATION 31: Monetary policy shock
Gamma0(31,izm) = 1;
Gamma1(31,izm) = rho_i;
%EQUATION 32: Technology shock
Gamma0(32,iza) = 1;
Gamma1(32,iza) = rho_a;

% CANONICAL FORM FOR GENSYS
Cst = zeros(nx,1);
Psi = [zeros(nx-numshock,numshock); stdmat];
Pi = zeros(nx,nd);
j = 1;
for i=(nx-numshock-nd+1):(nx-numshock)
    Pi(i,j) = 1;
    j = j+1;
end
[G1,~,impact,~,~,~,~,eu,~] = gensys(Gamma0,Gamma1,Cst,Psi,Pi,1+1E-8);

%% Plot impulse responses
irf_m = zeros(nx,h+1);
irf_a = zeros(nx,h+1);
if h>0
    for i = 1:h+1
        irf_m(:,i) = (G1^(i-1))*impact(:,1);
        irf_a(:,i) = (G1^(i-1))*impact(:,2);
    end
end
irf = [irf_m; irf_a];
% disp(eu');
% disp([kappa,kappaw]);