function [FractionsOfVarianceX,FractionsOfVarianceY]=GetFractionsOfVarianceCointegratedVAR(A0,BB,GG,LagOrder,N,Horizon,K)
% Here the matrices for the MA representation of the cointergated VAR:
[MAMatricesX,MAMatricesY]=GetMARepresentationCointegratedVECM(BB,GG,LagOrder,N,Horizon);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                    I: The variances conditional on all shocks:
Omega=A0*A0';
%
VariancesAllShocksX=[];
VariancesAllShocksY=[];
VariancesX=zeros(N,N);
VariancesY=zeros(N,N);
kk=1;
while kk<=Horizon+1
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    MAMatrixX=MAMatricesX(:,:,kk);
    VariancesX=VariancesX+MAMatrixX*Omega*MAMatrixX';
    VariancesAllShocksX=[VariancesAllShocksX; diag(VariancesX)'];
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    MAMatrixY=MAMatricesY(:,:,kk);
    VariancesY=VariancesY+MAMatrixY*Omega*MAMatrixY';
    VariancesAllShocksY=[VariancesAllShocksY; diag(VariancesY)'];
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    kk=kk+1;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                               II: The variances conditional on individual shocks and the fractions of variance:
%
FractionsOfVarianceX=zeros(Horizon+1,N,K);
FractionsOfVarianceY=zeros(Horizon+1,N,K);
for xx=1:K % Shock
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    CovarianceMatrixStructuralShocks=zeros(N,N);
    CovarianceMatrixStructuralShocks(xx,xx)=1;
    Omega=A0*CovarianceMatrixStructuralShocks*A0';
    % II: The variances conditional on individual shocks:
    VariancesIndividualShocksX=[];
    VariancesIndividualShocksY=[];
    VariancesX=zeros(N,N);
    VariancesY=zeros(N,N);
    kk=1;
    while kk<=Horizon+1
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        MAMatrixX=MAMatricesX(:,:,kk);
        VariancesX=VariancesX+MAMatrixX*Omega*MAMatrixX';
        VariancesIndividualShocksX=[VariancesIndividualShocksX; diag(VariancesX)'];
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        MAMatrixY=MAMatricesY(:,:,kk);
        VariancesY=VariancesY+MAMatrixY*Omega*MAMatrixY';
        VariancesIndividualShocksY=[VariancesIndividualShocksY; diag(VariancesY)'];
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        kk=kk+1;
    end
    FractionsOfVarianceX(:,:,xx)=VariancesIndividualShocksX./VariancesAllShocksX;
    FractionsOfVarianceY(:,:,xx)=VariancesIndividualShocksY./VariancesAllShocksY;
end






