function [MU,B]=GetVARInLevelsFromVECM(MU,BB,GG);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Given a VECM, this code computes the coefficients of the representation for the corresponding VAR in levels.
% These are the coefficients of the VECM representation (the notation for Alpha, CSI, and CSI0 is the same as
% in the code JohansenCointegratedVAREstimates.m, which in turn is based on Hamilton's book:
% MU=Alpha(:,:,1);
% BB=CSI(:,:,:,1);
% GG=CSI0(:,:,1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
N=size(BB,1);
LagOrder=size(BB,3);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Here we get the coefficients of the representation for the corresponding VAR in levels:
B=zeros(N,N,LagOrder+1);
B(:,:,1)=eye(N)+GG+BB(:,:,1);
for zz=2:LagOrder
    B(:,:,zz)=BB(:,:,zz)-BB(:,:,zz-1);
end
B(:,:,LagOrder+1)=-BB(:,:,LagOrder);



