% This program solves the discrete Lyapunov-equation
%
% Sigma = Gamma*Sigma*Gamma' + Pi*Sigma_{e}*Pi'
%
% for Sigma, i.e. the exact covariance matrix for a VAR(1).
% Sigma_{e} is a covariance matrix for shocks.

function V=dlyap_simple(gamma,pai,sigmae)


sigma0 = eye(length(gamma));
diff = 5;

while diff > 1e-10

sigma1 = gamma*sigma0*gamma' + pai*sigmae*pai';

diff=max(max(abs(sigma1-sigma0)));

sigma0 = sigma1;

end

V = sigma1;
